{*******************************************************}
{                                                       }
{          Check performance of code in Delphi          }
{                                                       }
{           Copyright (c) 2000 Andrei Roofin            }
{                                                       }
{              www - http://dsr.tomsk.ru                }
{             mail - ray@mail.tomsknet.ru               }
{                                                       }
{*******************************************************}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, UrsProfiler;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ListBox1: TListBox;
    btnRun: TButton;
    Memo1: TMemo;
    procedure btnRunClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure Nop1;
    function IsTextString(const Value: PChar):boolean;
    function IsTextString1(const Value: PChar):boolean;
    function IsTextString2(const Value: PChar):boolean;
    function IsTextString3(const Value: PChar):boolean;
    function IsTextString4(const Value: PChar):boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ TForm1 }

procedure TForm1.Nop1;
asm
//  nop
end;

procedure TForm1.btnRunClick(Sender: TObject);
const
  cIterationCount = 5;
var
  i: integer;
  s: string;
  p: PChar;
begin
  Nop1;
  s := '1234567890abcdefghijklmnopqrstuvwxyz'+
       '1234567890abcdefghijklmnopqrstuvwxyz'+
       #9+
       '1234567890abcdefghijklmnopqrstuvwxyz'+
       '1234567890abcdefghijklmnopqrstuvwxyz';
  p := PChar(s);
  rsProfiler.Clear;
  ListBox1.Clear;

  for i:=1 to cIterationCount do begin
    rsProfiler[0].Start; IsTextString(p);  rsProfiler[0].Stop;
    rsProfiler[1].Start; IsTextString1(p); rsProfiler[1].Stop;
    rsProfiler[2].Start; IsTextString2(p); rsProfiler[2].Stop;
    rsProfiler[3].Start; IsTextString3(p); rsProfiler[3].Stop;
    rsProfiler[4].Start; IsTextString4(p); rsProfiler[4].Stop;
  end;
  rsProfiler[0].Name := 'IsTextString';  ListBox1.Items.Add(rsProfiler[0].AsString);
  rsProfiler[1].Name := 'IsTextString1'; ListBox1.Items.Add(rsProfiler[1].AsString);
  rsProfiler[2].Name := 'IsTextString2'; ListBox1.Items.Add(rsProfiler[2].AsString);
  rsProfiler[3].Name := 'IsTextString3'; ListBox1.Items.Add(rsProfiler[3].AsString);
  rsProfiler[4].Name := 'IsTextString4'; ListBox1.Items.Add(rsProfiler[4].AsString);

end;



procedure TForm1.ListBox1Click(Sender: TObject);
var
  i,MethodIndex: integer;
  sl: TStringList;
  s,FileName: string;
begin
  Memo1.Lines.BeginUpdate;
  Memo1.Clear;
  MethodIndex := ListBox1.ItemIndex;
  FileName := ExtractFilePath(Application.ExeName)+'unit1.pas';
  if FileExists(FileName) then begin
    sl := TStringList.Create;
    try
      sl.LoadFromFile(FileName);
      i := sl.IndexOf(Format('// Method%d Begin',[MethodIndex]));
      if i>=0 then begin
        Inc(i);
        s := Format('// Method%d End',[MethodIndex]);
        While (i<sl.Count) and (CompareText(sl[i], s)<>0) do begin
          Memo1.Lines.Add(sl[i]);
          Inc(i);
        end;
      end;
    finally
      sl.Free;
    end;
  end;
  Memo1.Lines.EndUpdate;
end;

// Method0 Begin
function TForm1.IsTextString(const Value: PChar): boolean;
var
  i: integer;
begin
  Result := False;
  for i:=0 to StrLen(Value)-1 do
   if Value[i]<' ' then begin
     Result := True;
     Break;
   end;
end;
// Method0 End


// Method1 Begin
function TForm1.IsTextString1(const Value: PChar): boolean;
var
  i: integer;
begin
  if Value=nil then Result := False
   else begin
    i := 0;
    while Value[i]<>#0 do
      if Value[i]<' ' then Break else Inc(i);
    Result := Value[i]<>#0;
   end;
end;
// Method1 End


// Method2 Begin
function TForm1.IsTextString2(const Value: PChar): boolean;
var
  p: PChar;
begin
  if Value=nil then Result := False
   else begin
     p := Value;
     While p^>=' ' do Inc(p);
     Result := p^<>#0;
   end;
end;
// Method2 End


// Method3 Begin
function TForm1.IsTextString3(const Value: PChar): boolean;
var
  i: integer;
begin
  if Value=nil then Result := False
   else begin
    i := 0;
    while Value[i]<>#0 do
      if Value[i+1]>=' ' then
        if Value[i+2]>=' ' then
          if Value[i+3]>=' ' then Inc(i,4)
          else begin
            Inc(i,3);
            break;
          end
        else begin
          Inc(i,2);
          Break;
        end
      else begin
        Inc(i);
        break;
      end;
    Result := Value[i]<>#0;
   end;
end;
// Method3 End


// Method4 Begin
function TForm1.IsTextString4(const Value: PChar): boolean;
var
  i: cardinal;
  p: PInteger;
begin
  Result := False;
  if Value=nil then Exit;

   p := PInteger(Value);
   While True do begin
    i := p^ and $E0E0E0E0;
    i := (i or (i shl 1) or (i shl 2)) and $80808080;
    if i<>$80808080 then begin
      if (i and $00000080)<>0 then
        if (i and $00008000)=0 then Inc(PChar(p),1)
         else
        if (i and $00800000)=0 then Inc(PChar(p),2)
         else
        if (i and $80000000)=0 then Inc(PChar(p),3);
      Result := PChar(p)^<>#0;
      Break;
    end;
    Inc(p);
   end;
end;
// Method4 End


end.
